<?php

/**
 * This Software is the property of D Data Development
 * and is protected by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * key is a violation of the license agreement and will be
 * prosecuted by civil and criminal law.
 * D3 Data Development
 * Inhaber: Thomas Dartsch
 * Alle Rechte vorbehalten
 *
 * @package       "Bonuspunkte"
 * @version       3.0.1_PE4
 * @author        Thomas Dartsch <thomas.dartsch@shopmodule.com> / Markus Grtner <markus.gaertner@shopmodule.com>
 * @copyright (C) 2012, D3 Data Development
 * @see           http://www.shopmodule.com
 *                $Rev::                                               $:
 *                $Author::                                            $:
 *                $Date::                                              $:
 */
class d3_account_points extends d3_account_points_parent
{
    private $_sModId = 'd3points';

    /**
     * @return string
     */
    public function render()
    {
        $ret = parent::render();

        $this->_aViewData['blIsD3PointsActive'] = $this->d3IsD3PointsActive();
        $this->_aViewData['d3PointsSum']        = $this->getPointsTotalSum();

        return $ret;
    }

    /**
     * Ob Modul aktiv ist
     *
     * @return bool
     */
    public function d3IsD3PointsActive()
    {
        return d3_cfg_mod::get($this->_sModId)->isActive();
    }

    /**
     * Gibt die Summe der aktuellen Bonuspunkte zurck
     *
     * @return integer
     */
    public function getPointsTotalSum()
    {
        $oUser = $this->getUser();
        if (!$oUser) {
            return 0;
        }

        /* @var $oD3UserPoints d3_d3points_d3points */
        $oD3UserPoints = oxNew('d3_d3points_d3points');

        return $oD3UserPoints->d3GetTotalSumPoints($oUser->getId());
    }

    /**
     * @return mixed
     */
    public function d3GetParentThemeId()
    {
        /** @var d3_oxtheme_modcfg $oTheme */
        $oTheme = oxNew('oxTheme');
        return $oTheme->d3GetParentThemeId();
    }

}