<?php /** @noinspection PhpUndefinedClassInspection */

/**
 * This Software is the property of D� Data Development
 * and is protected by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * key is a violation of the license agreement and will be
 * prosecuted by civil and criminal law.
 * D3 Data Development
 * Inhaber: Thomas Dartsch
 * Alle Rechte vorbehalten
 *
 * @package       "Bonuspunkte"
 * @version       3.0.1_XE4
 * @author        Thomas Dartsch <thomas.dartsch@shopmodule.com> / Markus G�rtner <markus.gaertner@shopmodule.com>
 * @copyright (C) 2011, D3 Data Development
 * @see           http://www.shopmodule.com
 *                $Rev::                                               $:
 *                $Author::                                            $:
 *                $Date::                                              $:
 */
class d3_details_Points extends d3_details_points_parent
{

    private $_sModId = 'd3points';

    /**
     * Extends save-methode
     * Bewertung einzeln f�r Rating und Text
     * Option: if user can get points for more reviews for on article
     */
    public function saveReview()
    {
        //Modul ist aktiv
        if ($this->_getCfgMod()->isActive()) {
            $this->_getCfgMod()->getLog()->Log(
            d3log::DEBUG,
            __CLASS__,
            __FUNCTION__,
            __LINE__,
            "start check review points",
            "cl=details"
            );

            /* @var $oD3Rating d3_d3points_rating */
            $oD3Rating = oxnew('d3_d3points_rating');
            $this->_getCfgMod()->getLog()->Log(
            d3log::INFO,
            __CLASS__,
            __FUNCTION__,
            __LINE__,
            "start check review points",
            "cl=details"
            );

            if ($this->canAcceptFormData() && ($oUser = $this->getUser()) && ($oProduct = $this->getProduct())
            ) {

                $dRating = oxRegistry::getConfig()->getRequestParameter('artrating');
                if ($dRating !== null) {
                    $dRating = (int)$dRating;
                }
                $oD3Rating->d3SetUser($oUser->getId());
                $oD3Rating->d3SetArticleId($oProduct->getId());

                if ($dRating !== null && $dRating >= 0 && $dRating <= 5) {
                    /** @var $oRating oxrating */
                    $oRating = oxNew('oxrating');
                    if ($oRating->allowRating($oUser->getId(), 'oxarticle', $oProduct->getId())) {
                        $oD3Rating->d3SetPointsForRating();
                    }
                }
                if ($sReviewText = trim((string)oxRegistry::getConfig()->getRequestParameter('rvw_txt', true))) {
                    $oD3Rating->d3SetPointsForReview();
                }

                $oD3Rating->d3SendReviewMail();
            }

            $this->_getCfgMod()->getLog()->Log(
            d3log::INFO,
            __CLASS__,
            __FUNCTION__,
            __LINE__,
            "end check review points",
            "cl=details"
            );
        }

        parent::saveReview();
    }

    /**
     * @return object
     */
    public function _getCfgMod()
    {
        return d3_cfg_mod::get($this->_sModId);
    }
}