<?PHP

/**
 * This Software is the property of D Data Development
 * and is protected by copyright law - it is NOT Freeware.
 *
 * Any unauthorized use of this software without a valid license
 * key is a violation of the license agreement and will be
 * prosecuted by civil and criminal law.
 *
 * D3 Data Development
 * Inhaber: Thomas Dartsch
 * Alle Rechte vorbehalten
 *
 * @package "Bonuspunkte"
 * @author Thomas Dartsch <thomas.dartsch@shopmodule.com> / Markus Grtner <markus.gaertner@shopmodule.com>
 * @copyright (C) 2011, D3 Data Development
 * @see http://www.shopmodule.com
 *
 */
class d3_oxorder_d3points extends d3_oxorder_d3points_parent
{
    private $_sModId = 'd3points';
    private $_oSet;
    public  $iD3UpdatedOrders = 0;
    private $oD3Log;

    /**
     *
     */
    public function __construct()
    {
        parent::__construct();

        $this->_oSet = d3_cfg_mod::get($this->_sModId);
        $this->oD3Log = $this->_oSet->d3getLog();
    }

    /**
     * Save Status d3issetpoints to oxorder
     * 0 = order is not processed by cronjob
     * 1 = order is processed by cronjob
     *
     * @param string $sOrderId
     * @param integer $iSetPoints
     *
     * @return bool
     */
    public function d3UpdateOrderFieldD3IsSetPoints($sOrderId, $iSetPoints)
    {
        if ($this->load($sOrderId))
        {
            $this->assign(
                array('d3issetpoints'   => $iSetPoints)
            );
             return $this->save();
        }

        return false;
    }

    /**
     * Reset field d3issetpoints for alle orders
     * limit by Date
     *
     * @param integer $iStatus 0 / 1
     * @param bool $blStatus extrac checkbox in templates
     * @return bool
     */
    public function d3ResetOrders($iStatus, $blStatus)
    {
        if ($blStatus == true) {
            if (!$iStatus) {
                $iStatus = 0;
            }

            $oDb = oxDb::getDb(oxDb::FETCH_MODE_ASSOC);

            /* @var $od3points d3_d3points_d3points */
            $od3points          = oxnew('d3_d3points_d3points');
            $sD3PointsDateLimit = $od3points->d3GetDateLimitForOrders();
            $sDate              = date("Y-m-d", strtotime('-' . $sD3PointsDateLimit . ' month'));

            $sSelect =<<<MYSQL
SELECT count(oxid)
FROM {$this->_sCoreTable}
WHERE oxorderdate >= {$oDb->quote($sDate)}
AND OXSHOPID = {$oDb->quote($this->getConfig()->getShopId())}
MYSQL;

            $this->iD3UpdatedOrders = $oDb->getone($sSelect);

            $sUpdate = <<<MYSQL
UPDATE {$this->_sCoreTable}
SET d3issetpoints= {$oDb->quote($iStatus)}
WHERE  oxorderdate >= {$oDb->quote($sDate)}
AND OXSHOPID ={$oDb->quote($this->getConfig()->getShopId())}
MYSQL;


            d3_cfg_mod::get($this->_sModId)->d3getLog()->Log(
            d3log::INFO,
            __CLASS__,
            __FUNCTION__,
            __LINE__,
            "Reset Orders ",
            "Query: " . PHP_EOL . $sUpdate
            );

            #echo $sUpdate;
            $rs = $oDb->Execute($sUpdate);
            return $rs;
        } else {
            return false;
        }
    }

    /**
     * @return null|oxuser
     */
    public function d3getOrderUser()
    {
        /** @var oxuser $oUser */
        $oUser = oxNew("oxuser" );
        $oUser->load($this->getFieldData('oxuserid'));
        return $oUser;
    }
}